[![Build Status](https://travis-ci.org/hajee/connect_yaml.png?branch=master)](https://travis-ci.org/hajee/connect_yaml) [![Coverage Status](https://coveralls.io/repos/hajee/connect_yaml/badge.svg)](https://coveralls.io/r/hajee/connect_yaml)[![Code Climate](https://codeclimate.com/github/hajee/connect_yaml/badges/gpa.svg)](https://codeclimate.com/github/hajee/connect_yaml)

####Table of Contents

1. [Overview](#overview)
2. [Module Description - What YAML importer for Connect does and why it is useful](#module-description)
3. [Setup - The basics of getting started with the YAML importer for Connect](#setup)
    * [What connect affects](#what-connect-affects)
    * [Setup requirements](#setup-requirements)
    * [Beginning with the YAML importer for Connect](#beginning-with-connect)
    * [Tools](#tools)
4. [Usage - Configuration options and additional functionality](#usage)
5. [Troubleshooting](#troubleshooting)
6. [Limitations - OS compatibility, etc.](#limitations)
7. [Development - Guide for contributing to the module](#development)
    * [OS support](#os-support)
    * [Tests - Testing your configuration](#testing)

##Overview

[Connect](https://github.com/hajee/connect) is a replacement for YAML in hiera when using Puppet. Connect allows you to assign, manipulate and reference data. It  also allows you to import data items from external sources. The code to import this data is called a datasource.

##Module Description

This module contains the data source for reading YAML files into [Connect](https://github.com/hajee/connect). Although [Connect](https://github.com/hajee/connect), is build to get away from YAML, sometimes it is useful to be able to read and use the contents of a YAML file. This module allows you to do so.

##Example

Here is an example reading a YAML file.

```ruby
import from yaml('/aaa/a.yaml') do
  variable1 = 'key1'
  variable2 = 'yaml::key2'
end
```

In this example we are opening the file `/aaa/a.yaml`, and reading the keys `key1`  and ` yaml::Key2` . In the rest of the Connect configuration, you can use the variables  as ` variable1` and ` variable2`

##Setup

###Installing the module

To use the YAML datasource module, you first have to make sure it is installed.

```sh
puppet module install hajee/connect_yaml
```

If you are using a Puppetfile, you need the following lines:

```
mod 'hajee-connect_yaml'
```

No additional actions are required. Connect searches for available data sources when staring. So when this data source is installed, it is usable instantaneous.

###What connect_yaml affects

`connect_yaml`  affects no other modules then only Connect. 

###Setup Requirements

A requirement for ` connect_yaml`  is the [Connect]](https://github.com/hajee/connect), module. This requirement is specified in the module metadata so you don’t have to manage it yourself.

###Beginning with connect YAML module


Check [the Connect Language, in a Nutshell](https://github.com/hajee/connect/blob/master/doc/nutshell.md), for more intro into the language.

##Troubleshooting

Use the `--debug`  option to puppet to see what is happening

##Limitations

This module is tested CentOS and Redhat. It will probably work on other Linux distributions. 

##Development

This is an open source project, and contributions are welcome.

###OS support

Currently we have tested:

* CentOS 5
* Redhat 5

###Testing

Make sure you have:

* rake
* bundler

Install the necessary gems:

    bundle install

And run the tests from the root of the source code:

    rake spec

We are currently working on getting the acceptance test running as well.

